'G-Control Version 1.0
'All rights reserved by Alexander M. Prado

'$INCLUDE: 'future.bi'
DEFINT A-Z

'--- ListBox Control ---

'Properties procedures/functions
DECLARE FUNCTION ListBox.List$ (ControlID%, ListIndex&)
DECLARE FUNCTION ListBox.ListIndex& (ControlID%)
DECLARE SUB ListBox.SetListIndex (ControlID%, ListIndex&)
DECLARE SUB ListBox.SetList (ControlID%, ListIndex&, NewValue$)
DECLARE FUNCTION ListBox.Left% (ControlID%)
DECLARE FUNCTION ListBox.Top% (ControlID%)
DECLARE FUNCTION ListBox.Width% (ControlID%)
DECLARE FUNCTION ListBox.Height% (ControlID%)
DECLARE FUNCTION ListBox.TabStop% (ControlID%)
DECLARE SUB ListBox.SetTabStop (ControlID%, Value%)
DECLARE FUNCTION ListBox.SelectionVisible% (ControlID%)
DECLARE FUNCTION ListBox.ItemCount& (ControlID%)

'Method procedures/functions
DECLARE FUNCTION ListBox.Create% (Left%, Top%, Width.%, height%, ForeColor&, BackColor&, ScrollBar%, ItemMaxLen%, MaxItems&)
DECLARE SUB ListBox.AddItem (ControlID%, Item$)
DECLARE SUB ListBox.InsertItem (ControlID%, ListIndex&, Item$)
DECLARE SUB ListBox.RemoveItem (ControlID%, ListIndex&)
DECLARE SUB ListBox.DoEvent (ControlID%)
DECLARE SUB ListBox.Refresh (ControlID%)
DECLARE SUB ListBox.ReDraw (ControlID%)
DECLARE SUB ListBox.ReDrawAll ()
DECLARE SUB ListBox.Destroy (ControlID%)
DECLARE SUB ListBox.DestroyAll ()
DECLARE SUB ListBox.ShowSelection (ControlID%)

'Event procedures/functions
DECLARE FUNCTION ListBox.MouseDown% (ControlID%, Button%, Item&)
DECLARE FUNCTION ListBox.Click% (ControlID%, ItemClick&)
DECLARE FUNCTION ListBox.DblClick (ControlID%, Item&)
DECLARE FUNCTION ListBox.KeyPress% (ControlID%, KeyChar$)
DECLARE FUNCTION ListBox.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION ListBox.IndexChange% (ControlID%)
DECLARE FUNCTION ListBox.GotFocus% (ControlID%)
DECLARE FUNCTION ListBox.LostFocus% (ControlID%)
DECLARE FUNCTION ListBox.MouseOver% (ControlID%, Item&, X%, Y%)



'--- HScroll Control ---

'Properties procedures/functions
DECLARE SUB HScroll.SetLargeChange (ControlID%, Value%)
DECLARE SUB HScroll.SetMaxValue (ControlID%, Value&)
DECLARE SUB HScroll.SetValue (ControlID%, Value&)
DECLARE FUNCTION HScroll.MaxValue& (ControlID%)
DECLARE FUNCTION HScroll.Value& (ControlID%)
DECLARE FUNCTION HScroll.Left% (ControlID%)
DECLARE FUNCTION HScroll.Top% (ControlID%)
DECLARE FUNCTION HScroll.Width% (ControlID%)
DECLARE FUNCTION HScroll.TabStop% (ControlID%)
DECLARE SUB HScroll.SetTabStop (ControlID%, Value%)

'Method procedures/functions
DECLARE SUB HScroll.DoEvent (ControlID%)
DECLARE FUNCTION HScroll.Create% (Left%, Top%, Width.%, ForeColor&, BackColor&)
DECLARE SUB HScroll.ReDraw (ControlID%)
DECLARE SUB HScroll.ReDrawAll ()
DECLARE SUB HScroll.Destroy (ControlID%)
DECLARE SUB HScroll.DestroyAll ()

'Event procedures/functions
DECLARE FUNCTION HScroll.Change% (ControlID%)



'--- VScroll Control ---

'Properties procedures/functions
DECLARE SUB VScroll.SetLargeChange (ControlID%, Value%)
DECLARE SUB VScroll.SetMaxValue (ControlID%, Value&)
DECLARE SUB VScroll.SetValue (ControlID%, Value&)
DECLARE FUNCTION VScroll.MaxValue& (ControlID%)
DECLARE FUNCTION VScroll.Value& (ControlID%)
DECLARE FUNCTION VScroll.Left% (ControlID%)
DECLARE FUNCTION VScroll.Top% (ControlID%)
DECLARE FUNCTION VScroll.Height% (ControlID%)
DECLARE FUNCTION VScroll.TabStop% (ControlID%)
DECLARE SUB VScroll.SetTabStop (ControlID%, Value%)


'Method procedures/functions
DECLARE SUB VScroll.DoEvent (ControlID%)
DECLARE FUNCTION VScroll.Create% (Left%, Top%, Width.%, ForeColor&, BackColor&)
DECLARE SUB VScroll.ReDraw (ControlID%)
DECLARE SUB VScroll.ReDrawAll ()
DECLARE SUB VScroll.Destroy (ControlID%)
DECLARE SUB VScroll.DestroyAll ()

'Event procedures/functions
DECLARE FUNCTION VScroll.Change% (ControlID%)




'--- Button Control ---

'Properties procedures/functions
DECLARE FUNCTION Button.Caption$ (ControlID%)
DECLARE SUB Button.SetCaption (ControlID%, Caption$)
DECLARE FUNCTION Button.Left% (ControlID%)
DECLARE FUNCTION Button.Top% (ControlID%)
DECLARE FUNCTION Button.Width% (ControlID%)
DECLARE FUNCTION Button.Height% (ControlID%)
DECLARE FUNCTION Button.TabStop% (ControlID%)
DECLARE SUB Button.SetTabStop (ControlID%, Value%)

'Method procedures/functions
DECLARE FUNCTION Button.Create% (Caption$, Left%, Top%, Width.%, height%, ForeColor&, BackColor&)
DECLARE SUB Button.DoEvent (ControlID%)
DECLARE SUB Button.ReDraw (ControlID%)
DECLARE SUB Button.ReDrawAll ()
DECLARE SUB Button.Destroy (ControlID%)
DECLARE SUB Button.DestroyAll ()

'Event procedures/functions
DECLARE FUNCTION Button.KeyPress% (ControlID%, KeyChar$)
DECLARE FUNCTION Button.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION Button.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION Button.Click% (ControlID%)
DECLARE FUNCTION Button.GotFocus% (ControlID%)
DECLARE FUNCTION Button.LostFocus% (ControlID%)
DECLARE FUNCTION Button.MouseOver% (ControlID%, X%, Y%)



'--- TextBox Control ---

'Properties procedures/functions
DECLARE FUNCTION TextBox.Text$ (ControlID%)
DECLARE SUB TextBox.SetText (ControlID%, Text$)
DECLARE SUB TextBox.SetCursorType (ControlID%, CursorType%)
DECLARE FUNCTION TextBox.Left% (ControlID%)
DECLARE FUNCTION TextBox.Top% (ControlID%)
DECLARE FUNCTION TextBox.Width% (ControlID%)
DECLARE FUNCTION TextBox.Height% (ControlID%)
DECLARE FUNCTION TextBox.TabStop% (ControlID%)
DECLARE SUB TextBox.SetTabStop (ControlID%, Value%)
DECLARE FUNCTION TextBox.Line$ (ControlID%, LineNumber&)
DECLARE SUB TextBox.SetLine (ControlID%, LineNumber&, Text$)


'Method procedures/functions
DECLARE FUNCTION TextBox.Create% (Left%, Top%, Width.%, height%, ForeColor&, BackColor&, MaxChar%, MaxLines&)
DECLARE SUB TextBox.DoEvent (ControlID%)
DECLARE SUB TextBox.ReDraw (ControlID%)
DECLARE SUB TextBox.ReDrawAll ()
DECLARE SUB TextBox.Destroy (ControlID%)
DECLARE SUB TextBox.DestroyAll ()
DECLARE SUB TextBox.Refresh (ControlID%)

 
'Event procedures/functions
DECLARE FUNCTION TextBox.Change% (ControlID%)
DECLARE FUNCTION TextBox.KeyPress% (ControlID%, KeyChar$)
DECLARE FUNCTION TextBox.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION TextBox.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION TextBox.Click% (ControlID%)
DECLARE FUNCTION TextBox.GotFocus% (ControlID%)
DECLARE FUNCTION TextBox.LostFocus% (ControlID%)
DECLARE FUNCTION TextBox.MouseOver% (ControlID%, X%, Y%)


'--- CheckBox Control ---

'Properties procedures/functions
DECLARE FUNCTION CheckBox.Caption$ (ControlID%)
DECLARE SUB CheckBox.SetCaption (ControlID%, Caption$)
DECLARE FUNCTION CheckBox.Left% (ControlID%)
DECLARE FUNCTION CheckBox.Top% (ControlID%)
DECLARE FUNCTION CheckBox.TabStop% (ControlID%)
DECLARE SUB CheckBox.SetTabStop (ControlID%, Value%)
DECLARE FUNCTION CheckBox.Value% (ControlID%)
DECLARE SUB CheckBox.SetValue (ControlID%, Value%)

'Method procedures/functions
DECLARE FUNCTION CheckBox.Create% (Caption$, Left%, Top%, ForeColor&, BackColor&, CheckColor&, CheckBackColor&)
DECLARE SUB CheckBox.DoEvent (ControlID%)
DECLARE SUB CheckBox.ReDraw (ControlID%)
DECLARE SUB CheckBox.ReDrawAll ()
DECLARE SUB CheckBox.Destroy (ControlID%)
DECLARE SUB CheckBox.DestroyAll ()

'Event procedures/functions
DECLARE FUNCTION CheckBox.KeyPress% (ControlID%, KeyChar$)
DECLARE FUNCTION CheckBox.Click% (ControlID%)
DECLARE FUNCTION CheckBox.GotFocus% (ControlID%)
DECLARE FUNCTION CheckBox.LostFocus% (ControlID%)
DECLARE FUNCTION CheckBox.MouseDown% (ControlID%, Button%)
DECLARE FUNCTION CheckBox.MouseUp% (ControlID%, Button%)
DECLARE FUNCTION CheckBox.MouseOver% (ControlID%, X%, Y%)




'--- XMS Array procedures/functions ---

'XMS Array procedures/functions for 512 bytes string
DECLARE FUNCTION XMS512.GetItem$ (handle%, Index&)
DECLARE SUB XMS512.PutItem (handle%, Index&, charstr$)
DECLARE FUNCTION XMS512.Ubound& (AllocatedSize&)

'XMS Array procedures/functions for 256 bytes string
DECLARE SUB XMS256.PutItem (handle%, Index&, charstr$)
DECLARE FUNCTION XMS256.GetItem$ (handle%, Index&)
DECLARE FUNCTION XMS256.Ubound& (AllocatedSize&)

'XMS Array procedures/functions for 128 bytes string
DECLARE FUNCTION XMS128.GetItem$ (handle%, Index&)
DECLARE SUB XMS128.PutItem (handle%, Index&, charstr$)
DECLARE FUNCTION XMS128.Ubound& (AllocatedSize&)

'XMS Array procedures/functions for 64 bytes string
DECLARE FUNCTION XMS64.GetItem$ (handle%, Index&)
DECLARE SUB XMS64.PutItem (handle%, Index&, charstr$)
DECLARE FUNCTION XMS64.Ubound& (AllocatedSize&)

'XMS Array procedures/functions for 32 bytes string
DECLARE FUNCTION XMS32.GetItem$ (handle%, Index&)
DECLARE SUB XMS32.PutItem (handle%, Index&, charstr$)
DECLARE FUNCTION XMS32.Ubound& (AllocatedSize&)


'--- Two Dimensional XMS Array procedures/functions ---

TYPE XMS2D
  handle AS INTEGER
  xIndex AS INTEGER
  yIndex AS LONG
  xIndextotal AS LONG
  size AS INTEGER
END TYPE

DECLARE FUNCTION XMS2D.Allocate% (handle AS ANY, xIndex%, yIndex&, size%)
DECLARE FUNCTION XMS2D.GetSize& (xIndex%, yIndex&, size%)
DECLARE FUNCTION XMS2D.GetItem$ (handle AS ANY, xIndex%, yIndex&)
DECLARE SUB XMS2D.PutItem (handle AS ANY, xIndex%, yIndex&, charstr$)



'--- G-Control System procedures/functions ---

DECLARE SUB Updatekey ()
DECLARE FUNCTION UnivKey$ ()
DECLARE SUB UpdateMouse ()
DECLARE FUNCTION MouseX% ()
DECLARE FUNCTION MouseY% ()
DECLARE FUNCTION MouseB% ()
DECLARE SUB SetFocus (ControlID%)
DECLARE FUNCTION ActiveControl% ()
DECLARE FUNCTION RestoreControls% (SaveNumber%)
DECLARE FUNCTION SaveControls% (SaveNumber%)
DECLARE SUB SetTempDir (Value$)
DECLARE FUNCTION DelTempFiles% ()
DECLARE FUNCTION TempDir$ ()
DECLARE FUNCTION DblSpeed! ()
DECLARE SUB SetDblSpeed (Speed!)
DECLARE FUNCTION BlinkSpeed! ()
DECLARE SUB SetBlinkSpeed (Speed!)
DECLARE FUNCTION InitGCON% (MaxSave%, XMSMemNeeded&)
DECLARE SUB EndGCON ()

